/*
Stallation version 0.7  (2000-04-07)

Written by Peter Folk <pfolk@uni.uiuc.edu>

The contents of this file are in the public domain, but
the author would appreciate it if any useful changes or
corrections were communicated back to him, for inclusion
in a future version.
*/
#include "Stall_addon.h"
#include <string.h>
#include <stdlib.h>
#include <be/kernel/image.h>

status_t expand(const char* ref, const char* dest)
{
	status_t ret = B_ERROR;
	const char **argv = NULL;
	size_t argc=0;
	
	ssize_t len4 = strlen(ref)-4;
	if (len4<0){}
	else if (!strcmp(ref+len4,".zip"))
	{
		argv = new (const char *)[argc];
		argv[argc++] = "/bin/unzip";
		argv[argc++] = ref;
		argv[argc++] = "-d";
	}
	else if (!strcmp(ref+len4,".tar"))
	{
		argv = new (const char *)[6];
		argv[argc++] = "/bin/tar";
		argv[argc++] = "xf";
		argv[argc++] = ref;
		argv[argc++] = "-C";
	}
	else if (!strcmp(ref+len4,".tgz")
	     || (len4>3 && !strcmp(ref+len4-3,".tar.gz")))
	{
		argv = new (const char *)[6];
		argv[argc++] = "/bin/tar";
		argv[argc++] = "xzf";
		argv[argc++] = ref;
		argv[argc++] = "-C";
	}
	else if ((len4>2 && !strcmp(ref+len4-2,".tar.Z")))
	{
		argv = new (const char *)[6];
		argv[argc++] = "/bin/tar";
		argv[argc++] = "xZf";
		argv[argc++] = ref;
		argv[argc++] = "-C";
	}
	
	if (argv != NULL)
	{
		argv[argc++] = dest;
		argv[argc++] = 0;
		
		thread_id t = load_image(argc, argv, environ);
		wait_for_thread(t, &ret);
		if (ret==B_ERROR) --ret;
		
		delete[] argv;
	}
	
	return ret;
}
